import 'dart:convert';
import 'dart:io';
import 'dart:typed_data';

import 'package:crypto/crypto.dart';
import 'package:encrypt/encrypt.dart';
import 'config.dart';

Uint8List _encrypt(Key key, Uint8List bytes,
    {AESMode mode: AESMode.sic, IV? iv}) {
  iv = iv ?? IV.fromLength(key.bytes.length);
  return AES(key, mode: mode).encrypt(bytes, iv: iv).bytes;
}

Uint8List encryptHeader(Key key, VBDLHeader header) {
  return _encrypt(key, header.toBytes(), mode: VBDL_HEADER_ENCMODE);
}

Uint8List encryptIndex(Key key, Map<String, List<int>> indexMap) {
  final byteList = zlib.encode(utf8.encode(json.encode(indexMap)));
  final bytes = Uint8List.fromList(byteList);
  return _encrypt(key, bytes, mode: VBDL_INDEX_ENCMODE);
}

Uint8List encryptData(Key key, Uint8List bytes, int random) {
  bytes = Uint8List.fromList(zlib.encode(bytes));
  IV iv = IV(Uint8List.fromList(md5.convert(utf8.encode("$random")).bytes));
  return _encrypt(key, bytes, mode: VBDL_DATA_ENCMODE, iv: iv);
}
